diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/bindings/modulegen__gcc_LP64.py ns-3.34/src/internet/bindings/modulegen__gcc_LP64.py
--- ns-3.33/src/internet/bindings/modulegen__gcc_LP64.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:06.000000000 -0700
@@ -12697,6 +12842,8 @@
     cls.add_instance_attribute('m_initialSsThresh', 'uint32_t', is_const=False)
     ## tcp-socket-state.h (module 'internet'): ns3::TcpSocketState::m_isRetransDataAcked [variable]
     cls.add_instance_attribute('m_isRetransDataAcked', 'bool', is_const=False)
+    ## tcp-socket-state.h (module 'internet'): ns3::TcpSocketState::m_lastAckedSackedBytes [variable]
+    cls.add_instance_attribute('m_lastAckedSackedBytes', 'uint32_t', is_const=False)
     ## tcp-socket-state.h (module 'internet'): ns3::TcpSocketState::m_lastAckedSeq [variable]
     cls.add_instance_attribute('m_lastAckedSeq', 'ns3::SequenceNumber32', is_const=False)
     ## tcp-socket-state.h (module 'internet'): ns3::TcpSocketState::m_lastRtt [variable]
@@ -16012,10 +16159,10 @@
     cls.add_constructor([param('ns3::Ipv6 const &', 'arg0')])
     ## ipv6.h (module 'internet'): ns3::Ipv6::Ipv6() [constructor]
     cls.add_constructor([])
-    ## ipv6.h (module 'internet'): bool ns3::Ipv6::AddAddress(uint32_t interface, ns3::Ipv6InterfaceAddress address) [member function]
+    ## ipv6.h (module 'internet'): bool ns3::Ipv6::AddAddress(uint32_t interface, ns3::Ipv6InterfaceAddress address, bool addOnLinkRoute=true) [member function]
     cls.add_method('AddAddress', 
                    'bool', 
-                   [param('uint32_t', 'interface'), param('ns3::Ipv6InterfaceAddress', 'address')], 
+                   [param('uint32_t', 'interface'), param('ns3::Ipv6InterfaceAddress', 'address'), param('bool', 'addOnLinkRoute', default_value='true')], 
                    is_pure_virtual=True, is_virtual=True)
     ## ipv6.h (module 'internet'): uint32_t ns3::Ipv6::AddInterface(ns3::Ptr<ns3::NetDevice> device) [member function]
     cls.add_method('AddInterface', 
@@ -17005,10 +17152,10 @@
                    'int32_t', 
                    [param('ns3::Ptr< ns3::NetDevice const >', 'device')], 
                    is_const=True, is_virtual=True)
-    ## ipv6-l3-protocol.h (module 'internet'): bool ns3::Ipv6L3Protocol::AddAddress(uint32_t i, ns3::Ipv6InterfaceAddress address) [member function]
+    ## ipv6-l3-protocol.h (module 'internet'): bool ns3::Ipv6L3Protocol::AddAddress(uint32_t i, ns3::Ipv6InterfaceAddress address, bool addOnLinkRoute=true) [member function]
     cls.add_method('AddAddress', 
                    'bool', 
-                   [param('uint32_t', 'i'), param('ns3::Ipv6InterfaceAddress', 'address')], 
+                   [param('uint32_t', 'i'), param('ns3::Ipv6InterfaceAddress', 'address'), param('bool', 'addOnLinkRoute', default_value='true')], 
                    is_virtual=True)
     ## ipv6-l3-protocol.h (module 'internet'): ns3::Ipv6InterfaceAddress ns3::Ipv6L3Protocol::GetAddress(uint32_t interfaceIndex, uint32_t addressIndex) const [member function]
     cls.add_method('GetAddress', 
@@ -17139,6 +17286,10 @@
                    'bool', 
                    [param('ns3::Ipv6Address', 'address'), param('uint32_t', 'interface')], 
                    is_const=True)
+    ## ipv6-l3-protocol.h (module 'internet'): bool ns3::Ipv6L3Protocol::ReachabilityHint(uint32_t ipInterfaceIndex, ns3::Ipv6Address address) [member function]
+    cls.add_method('ReachabilityHint', 
+                   'bool', 
+                   [param('uint32_t', 'ipInterfaceIndex'), param('ns3::Ipv6Address', 'address')])
     ## ipv6-l3-protocol.h (module 'internet'): void ns3::Ipv6L3Protocol::DoDispose() [member function]
     cls.add_method('DoDispose', 
                    'void', 
@@ -17886,6 +18037,11 @@
     cls.add_method('FunctionRetransmitTimeout', 
                    'void', 
                    [])
+    ## ndisc-cache.h (module 'internet'): ns3::Ipv6Address ns3::NdiscCache::Entry::GetIpv6Address() const [member function]
+    cls.add_method('GetIpv6Address', 
+                   'ns3::Ipv6Address', 
+                   [], 
+                   is_const=True)
     ## ndisc-cache.h (module 'internet'): ns3::Time ns3::NdiscCache::Entry::GetLastReachabilityConfirmation() const [member function]
     cls.add_method('GetLastReachabilityConfirmation', 
                    'ns3::Time', 
@@ -18849,6 +19005,244 @@
                    is_virtual=True, visibility='protected')
     return
 
+def register_Ns3TcpBbr_methods(root_module, cls):
+    ## tcp-bbr.h (module 'internet'): ns3::TcpBbr::TcpBbr() [constructor]
+    cls.add_constructor([])
+    ## tcp-bbr.h (module 'internet'): ns3::TcpBbr::TcpBbr(ns3::TcpBbr const & sock) [constructor]
+    cls.add_constructor([param('ns3::TcpBbr const &', 'sock')])
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::CongControl(ns3::Ptr<ns3::TcpSocketState> tcb, ns3::TcpRateOps::TcpRateConnection const & rc, ns3::TcpRateOps::TcpRateSample const & rs) [member function]
+    cls.add_method('CongControl', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb'), param('ns3::TcpRateOps::TcpRateConnection const &', 'rc'), param('ns3::TcpRateOps::TcpRateSample const &', 'rs')], 
+                   is_virtual=True)
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::CongestionStateSet(ns3::Ptr<ns3::TcpSocketState> tcb, ns3::TcpSocketState::TcpCongState_t const newState) [member function]
+    cls.add_method('CongestionStateSet', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb'), param('ns3::TcpSocketState::TcpCongState_t const', 'newState')], 
+                   is_virtual=True)
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::CwndEvent(ns3::Ptr<ns3::TcpSocketState> tcb, ns3::TcpSocketState::TcpCAEvent_t const event) [member function]
+    cls.add_method('CwndEvent', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb'), param('ns3::TcpSocketState::TcpCAEvent_t const', 'event')], 
+                   is_virtual=True)
+    ## tcp-bbr.h (module 'internet'): ns3::Ptr<ns3::TcpCongestionOps> ns3::TcpBbr::Fork() [member function]
+    cls.add_method('Fork', 
+                   'ns3::Ptr< ns3::TcpCongestionOps >', 
+                   [], 
+                   is_virtual=True)
+    ## tcp-bbr.h (module 'internet'): std::string ns3::TcpBbr::GetName() const [member function]
+    cls.add_method('GetName', 
+                   'std::string', 
+                   [], 
+                   is_const=True, is_virtual=True)
+    ## tcp-bbr.h (module 'internet'): uint32_t ns3::TcpBbr::GetSsThresh(ns3::Ptr<const ns3::TcpSocketState> tcb, uint32_t bytesInFlight) [member function]
+    cls.add_method('GetSsThresh', 
+                   'uint32_t', 
+                   [param('ns3::Ptr< ns3::TcpSocketState const >', 'tcb'), param('uint32_t', 'bytesInFlight')], 
+                   is_virtual=True)
+    ## tcp-bbr.h (module 'internet'): static ns3::TypeId ns3::TcpBbr::GetTypeId() [member function]
+    cls.add_method('GetTypeId', 
+                   'ns3::TypeId', 
+                   [], 
+                   is_static=True)
+    ## tcp-bbr.h (module 'internet'): bool ns3::TcpBbr::HasCongControl() const [member function]
+    cls.add_method('HasCongControl', 
+                   'bool', 
+                   [], 
+                   is_const=True, is_virtual=True)
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::SetStream(uint32_t stream) [member function]
+    cls.add_method('SetStream', 
+                   'void', 
+                   [param('uint32_t', 'stream')], 
+                   is_virtual=True)
+    ## tcp-bbr.h (module 'internet'): ns3::TcpBbr::BbrModeName [variable]
+    cls.add_static_attribute('BbrModeName', 'char const * [ 4 ] const', is_const=True)
+    ## tcp-bbr.h (module 'internet'): ns3::TcpBbr::GAIN_CYCLE_LENGTH [variable]
+    cls.add_static_attribute('GAIN_CYCLE_LENGTH', 'uint8_t const', is_const=True)
+    ## tcp-bbr.h (module 'internet'): ns3::TcpBbr::PACING_GAIN_CYCLE [variable]
+    cls.add_static_attribute('PACING_GAIN_CYCLE', 'double [ 0 ] const', is_const=True)
+    ## tcp-bbr.h (module 'internet'): uint32_t ns3::TcpBbr::AckAggregationCwnd() [member function]
+    cls.add_method('AckAggregationCwnd', 
+                   'uint32_t', 
+                   [], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::AdvanceCyclePhase() [member function]
+    cls.add_method('AdvanceCyclePhase', 
+                   'void', 
+                   [], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::CheckCyclePhase(ns3::Ptr<ns3::TcpSocketState> tcb, ns3::TcpRateOps::TcpRateSample const & rs) [member function]
+    cls.add_method('CheckCyclePhase', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb'), param('ns3::TcpRateOps::TcpRateSample const &', 'rs')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::CheckDrain(ns3::Ptr<ns3::TcpSocketState> tcb) [member function]
+    cls.add_method('CheckDrain', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::CheckFullPipe(ns3::TcpRateOps::TcpRateSample const & rs) [member function]
+    cls.add_method('CheckFullPipe', 
+                   'void', 
+                   [param('ns3::TcpRateOps::TcpRateSample const &', 'rs')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::CheckProbeRTT(ns3::Ptr<ns3::TcpSocketState> tcb, ns3::TcpRateOps::TcpRateSample const & rs) [member function]
+    cls.add_method('CheckProbeRTT', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb'), param('ns3::TcpRateOps::TcpRateSample const &', 'rs')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::EnterDrain() [member function]
+    cls.add_method('EnterDrain', 
+                   'void', 
+                   [], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::EnterProbeBW() [member function]
+    cls.add_method('EnterProbeBW', 
+                   'void', 
+                   [], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::EnterProbeRTT() [member function]
+    cls.add_method('EnterProbeRTT', 
+                   'void', 
+                   [], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::EnterStartup() [member function]
+    cls.add_method('EnterStartup', 
+                   'void', 
+                   [], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::ExitProbeRTT() [member function]
+    cls.add_method('ExitProbeRTT', 
+                   'void', 
+                   [], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): uint32_t ns3::TcpBbr::GetBbrState() [member function]
+    cls.add_method('GetBbrState', 
+                   'uint32_t', 
+                   [], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): double ns3::TcpBbr::GetCwndGain() [member function]
+    cls.add_method('GetCwndGain', 
+                   'double', 
+                   [], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): double ns3::TcpBbr::GetPacingGain() [member function]
+    cls.add_method('GetPacingGain', 
+                   'double', 
+                   [], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::HandleProbeRTT(ns3::Ptr<ns3::TcpSocketState> tcb) [member function]
+    cls.add_method('HandleProbeRTT', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::HandleRestartFromIdle(ns3::Ptr<ns3::TcpSocketState> tcb, ns3::TcpRateOps::TcpRateSample const & rs) [member function]
+    cls.add_method('HandleRestartFromIdle', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb'), param('ns3::TcpRateOps::TcpRateSample const &', 'rs')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): uint32_t ns3::TcpBbr::InFlight(ns3::Ptr<ns3::TcpSocketState> tcb, double gain) [member function]
+    cls.add_method('InFlight', 
+                   'uint32_t', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb'), param('double', 'gain')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::InitFullPipe() [member function]
+    cls.add_method('InitFullPipe', 
+                   'void', 
+                   [], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::InitPacingRate(ns3::Ptr<ns3::TcpSocketState> tcb) [member function]
+    cls.add_method('InitPacingRate', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::InitRoundCounting() [member function]
+    cls.add_method('InitRoundCounting', 
+                   'void', 
+                   [], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): bool ns3::TcpBbr::IsNextCyclePhase(ns3::Ptr<ns3::TcpSocketState> tcb, ns3::TcpRateOps::TcpRateSample const & rs) [member function]
+    cls.add_method('IsNextCyclePhase', 
+                   'bool', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb'), param('ns3::TcpRateOps::TcpRateSample const &', 'rs')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::ModulateCwndForProbeRTT(ns3::Ptr<ns3::TcpSocketState> tcb) [member function]
+    cls.add_method('ModulateCwndForProbeRTT', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): bool ns3::TcpBbr::ModulateCwndForRecovery(ns3::Ptr<ns3::TcpSocketState> tcb, ns3::TcpRateOps::TcpRateSample const & rs) [member function]
+    cls.add_method('ModulateCwndForRecovery', 
+                   'bool', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb'), param('ns3::TcpRateOps::TcpRateSample const &', 'rs')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::RestoreCwnd(ns3::Ptr<ns3::TcpSocketState> tcb) [member function]
+    cls.add_method('RestoreCwnd', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::SaveCwnd(ns3::Ptr<const ns3::TcpSocketState> tcb) [member function]
+    cls.add_method('SaveCwnd', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState const >', 'tcb')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::SetBbrState(ns3::TcpBbr::BbrMode_t state) [member function]
+    cls.add_method('SetBbrState', 
+                   'void', 
+                   [param('ns3::TcpBbr::BbrMode_t', 'state')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::SetCwnd(ns3::Ptr<ns3::TcpSocketState> tcb, ns3::TcpRateOps::TcpRateSample const & rs) [member function]
+    cls.add_method('SetCwnd', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb'), param('ns3::TcpRateOps::TcpRateSample const &', 'rs')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::SetPacingRate(ns3::Ptr<ns3::TcpSocketState> tcb, double gain) [member function]
+    cls.add_method('SetPacingRate', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb'), param('double', 'gain')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::SetSendQuantum(ns3::Ptr<ns3::TcpSocketState> tcb) [member function]
+    cls.add_method('SetSendQuantum', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::UpdateAckAggregation(ns3::Ptr<ns3::TcpSocketState> tcb, ns3::TcpRateOps::TcpRateSample const & rs) [member function]
+    cls.add_method('UpdateAckAggregation', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb'), param('ns3::TcpRateOps::TcpRateSample const &', 'rs')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::UpdateBtlBw(ns3::Ptr<ns3::TcpSocketState> tcb, ns3::TcpRateOps::TcpRateSample const & rs) [member function]
+    cls.add_method('UpdateBtlBw', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb'), param('ns3::TcpRateOps::TcpRateSample const &', 'rs')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::UpdateControlParameters(ns3::Ptr<ns3::TcpSocketState> tcb, ns3::TcpRateOps::TcpRateSample const & rs) [member function]
+    cls.add_method('UpdateControlParameters', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb'), param('ns3::TcpRateOps::TcpRateSample const &', 'rs')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::UpdateModelAndState(ns3::Ptr<ns3::TcpSocketState> tcb, ns3::TcpRateOps::TcpRateSample const & rs) [member function]
+    cls.add_method('UpdateModelAndState', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb'), param('ns3::TcpRateOps::TcpRateSample const &', 'rs')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::UpdateRTprop(ns3::Ptr<ns3::TcpSocketState> tcb) [member function]
+    cls.add_method('UpdateRTprop', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::UpdateRound(ns3::Ptr<ns3::TcpSocketState> tcb, ns3::TcpRateOps::TcpRateSample const & rs) [member function]
+    cls.add_method('UpdateRound', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb'), param('ns3::TcpRateOps::TcpRateSample const &', 'rs')], 
+                   visibility='protected')
+    ## tcp-bbr.h (module 'internet'): void ns3::TcpBbr::UpdateTargetCwnd(ns3::Ptr<ns3::TcpSocketState> tcb) [member function]
+    cls.add_method('UpdateTargetCwnd', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::TcpSocketState >', 'tcb')], 
+                   visibility='protected')
+    return
+
 def register_Ns3TcpBic_methods(root_module, cls):
     ## tcp-bic.h (module 'internet'): ns3::TcpBic::TcpBic() [constructor]
     cls.add_constructor([])
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/internet/examples/main-simple.cc ns-3.34/src/internet/examples/main-simple.cc
--- ns-3.33/src/internet/examples/main-simple.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/internet/examples/main-simple.cc	2021-07-14 10:31:06.000000000 -0700
@@ -26,21 +26,34 @@
 
 using namespace ns3;
 
+/**
+ * Generates traffic.
+ *
+ * The first call sends a packet of the specified size, and then
+ * the function is scheduled to send a packet of (size-50) after 0.5s.
+ * The process is iterated until the packet size is zero.
+ *
+ * \param socket output socket
+ * \param size packet size
+ */
 static void
-GenerateTraffic (Ptr<Socket> socket, uint32_t size)
+GenerateTraffic (Ptr<Socket> socket, int32_t size)
 {
-  std::cout << "at=" << Simulator::Now ().GetSeconds () << "s, tx bytes=" << size << std::endl;
-  socket->Send (Create<Packet> (size));
-  if (size > 0)
-    {
-      Simulator::Schedule (Seconds (0.5), &GenerateTraffic, socket, size - 50);
-    }
-  else
+  if (size <= 0)
     {
       socket->Close ();
+      return;
     }
+
+  std::cout << "at=" << Simulator::Now ().GetSeconds () << "s, tx bytes=" << size << std::endl;
+  socket->Send (Create<Packet> (size));
+  Simulator::Schedule (Seconds (0.5), &GenerateTraffic, socket, size - 50);
 }
 
+/**
+ * Prints the packets received by a socket
+ * \param socket input socket
+ */
 static void
 SocketPrinter (Ptr<Socket> socket)
 {
@@ -51,15 +64,11 @@
     }
 }
 
-static void
-PrintTraffic (Ptr<Socket> socket)
+int main (int argc, char *argv[])
 {
-  socket->SetRecvCallback (MakeCallback (&SocketPrinter));
-}
+  CommandLine cmd (__FILE__);
+  cmd.Parse (argc, argv);
 
-void
-RunSimulation (void)
-{
   NodeContainer c;
   c.Create (1);
 
@@ -77,20 +86,11 @@
   source->Connect (remote);
 
   GenerateTraffic (source, 500);
-  PrintTraffic (sink);
-
+  sink->SetRecvCallback (MakeCallback (&SocketPrinter));
 
   Simulator::Run ();
 
   Simulator::Destroy ();
-}
-
-int main (int argc, char *argv[])
-{
-  CommandLine cmd (__FILE__);
-  cmd.Parse (argc, argv);
-  
-  RunSimulation ();
 
   return 0;
 }
